"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const discord_js_1 = require("discord.js");
const main_1 = require("../../main");
const config_1 = require("../../config");
module.exports = {
    data: new discord_js_1.SlashCommandBuilder()
        .setName('config')
        .setDescription('Manage config')
        .addSubcommand(subcommand => subcommand
        .setName("set")
        .setDescription("Set config for a server or yourself (user)")
        .addStringOption(option => option
        .setName("setting")
        .setDescription("The setting to set")
        .setRequired(true))
        .addStringOption(option => option
        .setName("value")
        .setDescription("The value of setting")
        .setRequired(true))),
    execute(interaction) {
        return __awaiter(this, void 0, void 0, function* () {
            var _a, _b;
            const subCommand = interaction.options.getSubcommand();
            switch (subCommand) {
                case "set":
                    const key = interaction.options.getString("setting");
                    const keyShort = key.substring(key.indexOf(".") + 1);
                    const value = interaction.options.getString("value");
                    const botConfigValues = (_a = main_1.bot.info) === null || _a === void 0 ? void 0 : _a.configs;
                    const scope = key.split(".")[0];
                    if (!scope ||
                        !botConfigValues ||
                        !((_b = botConfigValues[scope]) === null || _b === void 0 ? void 0 : _b.includes(keyShort)))
                        return yield interaction.reply({ content: `❌ Invalid Setting` });
                    let id;
                    switch (scope) {
                        case config_1.ConfigTypes.Guild:
                            id = interaction.guildId;
                            break;
                        case config_1.ConfigTypes.User:
                            id = interaction.user.id;
                            break;
                    }
                    config_1.Config.set(scope, id, key, value);
                    yield interaction.reply({ content: `✅ Set \`${key}\` to \`${value}\`` });
                    break;
                default:
                    break;
            }
        });
    },
};
