"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Config = exports.ConfigTypes = void 0;
const main_1 = require("./main");
var ConfigTypes;
(function (ConfigTypes) {
    ConfigTypes["Guild"] = "guild";
    ConfigTypes["User"] = "user";
})(ConfigTypes || (exports.ConfigTypes = ConfigTypes = {}));
class Config {
    static getRaw(scope, id, key) {
        return __awaiter(this, void 0, void 0, function* () {
            const valueRaw = yield (0, main_1.knex)("config").where({
                scope: scope,
                id: id,
                key: key
            }).first();
            return valueRaw;
        });
    }
    static get(scope, id, key) {
        return __awaiter(this, void 0, void 0, function* () {
            const valueRaw = yield this.getRaw(scope, id, key);
            const value = valueRaw === null || valueRaw === void 0 ? void 0 : valueRaw.value;
            if (!value)
                return null;
            return value;
        });
    }
    static set(scope, id, key, value) {
        return __awaiter(this, void 0, void 0, function* () {
            const valueRaw = yield this.getRaw(scope, id, key);
            if (valueRaw) {
                yield (0, main_1.knex)("config").where({
                    scope: scope,
                    id: id,
                    key: key
                }).update({
                    value: value
                });
                return;
            }
            yield (0, main_1.knex)("config").insert({
                scope: scope,
                id: id,
                key: key,
                value: value
            });
            const event = this.setEvents.get(key);
            if (event)
                yield event({
                    scope: scope,
                    id: id,
                    key: key,
                    value: value
                });
        });
    }
    static onSet(key, func) {
        return __awaiter(this, void 0, void 0, function* () {
            this.setEvents.set(key, func);
        });
    }
}
exports.Config = Config;
Config.setEvents = new Map();
